//=======================================================================
//    cnewmdlg.cpp:	Source for CNewProjMDlg class
//    This is part of VIDE. See videapp.h for copyrights.
//    Version 2.00	date: 17 Mar 2003 16:48:57
//
//  Notes:
//
//	The Windows version has pretty good support for MinGW, Cygwin, and Borland
//
//	The X version is limited. It very specifically supports only
//	(These comments may not really apply as of version 2.00,  but I haven't checked)
//	    V GUI on Linux X11R6 platforms at the moment.
//
//	The X version lacks support for:
//		OpenGL
//		building libraries
//		gtk
//		Non Linux platforms
//
//	Hey, its FREE! You want more, feel free to help!
//
//=======================================================================

#include "cnewmdlg.h"
#include "videapp.h"
#include <v/vnotice.h>
#include <v/vreply.h>

//@V@:BeginIDs
    enum {
	lblMsg = 1500,
	frmM,
	frmC,
	frmD,
	lblC,
	lblTgt, txiTgt,
	lblT,
	lblDb,
	rdbC,
	rdbCPP,
	rdbCon,
	rdbGUI,
	rdbLib,
	rdbDLL,
	rdbMing,
	rdbCyg,
	rdbBorland,
	rdbOther,
	rdbRel,
	rdbDbg,
	blk1,
	blk2,
	blk3,
	txiRes,
	chkV,
	chkVdll,
	chkVMotif,
	chkVAthena,
	chkGL,
	chkRes,
	chkNoCyg,
	lastone
  };
//@V@:EndIds

//@V@:BeginDialogCmd DefaultCmds
    static DialogCmd WCmds[] =
      {
	{C_Label, lblMsg, 0,"Project Type:",NoList,CA_None,isSens,NoFrame, 0, 0},
	{C_RadioButton,rdbCPP,1,"C++/C",NoList,CA_None,isSens,NoFrame,
		lblMsg,0,0,"Create a C++ or mixed C++/C language project"},
	{C_RadioButton,rdbC,0,"C Only",NoList,CA_None,isSens,NoFrame,
		rdbCPP,0,0,"Create a C only language project"},

	{C_Label, lblTgt, 0, "Target name: ",NoList,CA_None,isSens,NoFrame,0,lblMsg},
	{C_TextIn, txiTgt,0,"",NoList,CA_None,isSens,NoFrame,lblTgt,lblMsg,0,
	    "Name of target, e.g., foo.exe, foo.a"},

	{C_Frame, frmM, 0, 0, NoList,CA_None,isSens,NoFrame,0,txiTgt},

	{C_Label, lblT,0,"Type of build",NoList,CA_None,isSens,frmM,0,0},
	{C_RadioButton,rdbCon,0,"Console Application",NoList,CA_None,isSens,frmM,
		0,lblT,0,"Build a console application"},
	{C_RadioButton,rdbGUI,1,"GUI Application",NoList,CA_None,isSens,frmM,
		0,rdbCon,0,"Build a GUI application"},
	{C_Blank,blk1,0,"  ",NoList,CA_None,isSens,frmM,0,rdbGUI},

#ifdef V_VersionX
	{C_CheckBox,chkVMotif,0,"Use V GUI (Motif)",NoList,CA_None,isSens,frmM,
		blk1,rdbGUI,0,"Build GUI App using Open Motif V GUI framework lib"},
	{C_CheckBox,chkVAthena,0,"Use V GUI (Athena)",NoList,CA_None,isSens,frmM,
		blk1,chkVMotif,0,"Build GUI App using Athena V GUI framework lib"},

	{C_CheckBox,chkVAthena,0,"Use V GUI (Athena)",NoList,CA_None,isSens,frmM,
		blk1,chkVMotif,0,"Build GUI App using Athena V GUI framework lib"},

	{C_CheckBox,chkGL,0,"Use OpenGL",NoList,CA_None,isSens,frmM,
		blk1,chkVAthena,0,"Build GUI App using OpenGL"},
#endif

#ifdef V_VersionWindows
	{C_CheckBox,chkV,0,"Use V GUI (static)",NoList,CA_None,isSens,frmM,
		blk1,rdbGUI,0,"Build GUI App using static V GUI framework lib"},
	{C_CheckBox,chkVdll,0,"Use V GUI (DLL)",NoList,CA_None,isSens,frmM,
		blk1,chkV,0,"Build GUI App using DLL V GUI framework lib"},
	{C_CheckBox,chkGL,0,"Use OpenGL",NoList,CA_None,isSens,frmM,
		blk1,chkVdll,0,"Build GUI App using OpenGL"},

	{C_RadioButton,rdbLib,0,"Static Library",NoList,CA_None,isSens,frmM,
		0,chkGL,0,"Build a static library"},
#ifdef NEWDLL
	{C_RadioButton,rdbDLL,0,"Dynamimc Library (DLL)",NoList,CA_None,notSens,frmM,
		0,rdbLib,0,"Build a dynamic link library (DLL)"},
#endif
#endif

	{C_Frame,frmD,0,0,NoList,CA_None,isSens,NoFrame,frmM,txiTgt},
	{C_Label,lblDb,0,"Release/Debug",NoList,CA_None,isSens,frmD,0,0},
	{C_RadioButton,rdbRel,1,"Release Version",NoList,CA_None,isSens,
		frmD,0,lblDb,0,"Build release version - no debugging"},
	{C_RadioButton,rdbDbg,0,"Debug Version",NoList,CA_None,isSens,
		frmD,0,rdbRel,0,"Build debug version - include debugging info"},

#ifdef V_VersionWindows
	{C_Frame,frmC,0,0,NoList,CA_None,isSens,NoFrame,frmM,frmD},
	{C_Label,lblC,0,"Compiler",NoList,CA_None,isSens,frmC,0,0},
	{C_RadioButton,rdbMing,1,"MinGW ",NoList,CA_None,isSens,frmC,
		0,lblC,0,"Using MingGW compiler"},
	{C_RadioButton,rdbCyg,0,"Cygwin ",NoList,CA_None,isSens,frmC,
		0,rdbMing,0,"Using Cygwin environment"},
	{C_Blank,blk3,0,"  ",NoList,CA_None,isSens,frmC,0,rdbCyg},
	{C_CheckBox,chkNoCyg,0,"-mno-cygwin",NoList,CA_None,isSens,frmC,
		blk3,rdbCyg,0,"Don't use Cygwin DLL"},
	{C_RadioButton,rdbBorland,0,"Borland BCC32 ",NoList,CA_None,isSens,frmC,
		0,chkNoCyg,0,"Use Borland BCC32 5.5 Compiler"},

	{C_RadioButton,rdbOther,0,"Other compiler",NoList,CA_None,isSens,frmC,
		0,rdbBorland,0,"Using some other compiler (you are on your own!)"},

	{C_Button, M_OK, 0, "   OK   ", NoList, CA_DefaultButton,
	    isSens, NoFrame, 0, frmC},
	{C_Button, M_Cancel, 0, " Cancel ",NoList,CA_None,
	    isSens,NoFrame,M_OK, frmC},
#else
	{C_Button, M_OK, 0, "   OK   ", NoList, CA_DefaultButton,
	    isSens, NoFrame, 0, frmM},
	{C_Button, M_Cancel, 0, " Cancel ",NoList,CA_None,
	    isSens,NoFrame,M_OK, frmM},
#endif

	{C_EndOfList,0,0,0,0,CA_None,0,0,0}
    };
//@V@:EndDialogCmd


//======================>>> CNewProjMDlg::CNewProjMDlg <<<==================
  CNewProjMDlg::CNewProjMDlg(makefileMaker* m,
   vBaseWindow* bw, char* title) : vModalDialog(bw, title)
  {
    mm = m;
    cmdw = (videCmdWindow*) bw;
    AddDialogCmds(WCmds);		// add the predefined commands
  }

//===================>>> CNewProjMDlg::~CNewProjMDlg <<<====================
  CNewProjMDlg::~CNewProjMDlg()
  {
    UserDebug(Destructor,"CNewProjMDlg::~CNewProjMDlg() destructor\n")
  }

//====================>>> CNewProjMDlg::CNewProjWizard <<<====================
  int CNewProjMDlg::CNewProjWizard(char* msg)
  {
    ItemVal ans,rval;

    ans = ShowModalDialog(msg,rval);
    if (ans == M_Cancel)
	return 0;

#ifdef V_VersionWindows
    if (GetValue(rdbBorland))
      {
	setBorlandValues();
	return ans == M_OK;
      }
#endif

    if (GetValue(rdbCPP))			// c++ project
	mm->SetCC ("g++");
    else
	mm->SetCC ("gcc");

    mm->setLdFlags ("");			// no ld flags for simple console

    mm->SetDebugSwitches ("-nw");		// non-window version

    if (GetValue(rdbDbg))			// Debug version
      {
	mm->SetCFlags ("-g");		// debug flag
      }
    else					// Releae version
      {
	mm->SetCFlags ("-O");		// optimize flag
#ifdef V_VersionWindows
	mm->setLdFlags ("-s");
#endif
      }

    char textIn[maxFileNameSize + 1];
    GetTextIn(txiTgt, textIn, maxFileNameSize);
    mm->SetExeName (textIn);

#ifdef V_VersionX		// X X X X X X X

    if (GetValue(rdbCon))			// Console app
      {
	// nothing to do!
      }
    else if (GetValue(rdbGUI))			// GUI
      {
	if (GetValue(chkVAthena))		// stuff for V Athena
	  {
	    //libraries += VX_LIB_OPTION XATHENA_LIB_OPTION;
	    (mm->libFiles)->insert(-1,"libVx");
	    (mm->libFiles)->insert(-1,"libXaw");
	    (mm->libFiles)->insert(-1,"libXmu");
	    (mm->libFiles)->insert(-1,"libXt");
	    (mm->libFiles)->insert(-1,"libXext");
	    (mm->libFiles)->insert(-1,"libX11");
	    
	    if (GetValue(chkGL))			// use OpenGL
	      {
		// libraries += VXGL_LIB_OPTION OGL_LIB_OPTION;
		(mm->libFiles)->insert(-1,"libVxgl");
#ifdef UseVGLw
		(mm->libFiles)->insert(-1,"libGLw");
#endif
		(mm->libFiles)->insert(-1,"libGLU");
		(mm->libFiles)->insert(-1,"libGL");
	      }
	    (mm->curDefs)->insert (-1, XATHENA_DEFINE);
	    (mm->defsPool)->insert (-1, XATHENA_DEFINE);
	  }
	else if (GetValue(chkVMotif))		// stuff for V Motif
	  {
	    //libraries += V_LIB_OPTION XMOTIF_LIB_OPTION;
	    (mm->libFiles)->insert(-1,"libV");
	    (mm->libFiles)->insert(-1,"libXm");
	    (mm->libFiles)->insert(-1,"libXp");
	    (mm->libFiles)->insert(-1,"libXt");
	    (mm->libFiles)->insert(-1,"libXext");
	    (mm->libFiles)->insert(-1,"libX11");
	    if (GetValue(chkGL))			// use OpenGL
	      {
		//libraries += VGL_LIB_OPTION OGL_LIB_OPTION;
		(mm->libFiles)->insert(-1,"libVgl");
#ifdef UseVGLw
		(mm->libFiles)->insert(-1,"libGLw");
#endif
		(mm->libFiles)->insert(-1,"libGLU");
		(mm->libFiles)->insert(-1,"libGL");
	      }
	  }
      }

    (mm->libDirs)->insert (-1, X_LIBRARY_PATH);
    (mm->incDirs)->insert (-1, X_INCLUDE_PATH);

#endif				// X X X X X X X

#ifdef V_VersionWindows		// WINDOWS WINDOWS WINDOWS WINDOWS WINDOWS

    std::string libraries = mm->getLdFlags();

    if (GetValue(rdbCyg))
      {
	if (GetValue(chkNoCyg))
	{
	    libraries += GCC_NO_CYGWIN_OPTION;
	}
      }

    std::string homeV = mm->GetHomeV ();
    if (!GetValue(chkV) && !GetValue(chkVdll))
	homeV = "";
    normalizePath (homeV);
    mm->SetHomeV ( homeV.c_str() );

    if (GetValue(rdbCon))			// Console app
      {
	// nothing to do!
      }
    else if (GetValue(rdbGUI))			// GUI
      {
	libraries += GCC_WINDOWS_OPTION;	// -mwindows
	if (GetValue(rdbCyg))			// cygwin?
	  {
	    libraries += " -e _mainCRTStartup";
	  }
	if (GetValue(chkV))			// stuff for V
	  {
	    (mm->libFiles)->insert(-1,V_LIB_OPTION);
	    (mm->libFiles)->insert(-1,"libcomctl32");
	    (mm->libDirs)->insert(-1,"$(HOMEV)/lib");
	    (mm->incDirs)->insert(-1,"$(HOMEV)/include");
	  }
	if (GetValue(chkVdll))			// stuff for V
	  {
	    (mm->libFiles)->insert(-1,VDLL_OPTION);
	    (mm->libDirs)->insert (-1,"$(HOMEV)/lib");
	    (mm->incDirs)->insert (-1,"$(HOMEV)/include");
	    (mm->curDefs)->insert (-1, VDLL_DEFINE);
	    (mm->defsPool)->insert (-1,VDLL_DEFINE);
	  }

	if (GetValue(chkGL))			// use OpenGL
	 {
	    if (GetValue(chkV))
	      {
		(mm->libFiles)->insert(-1,VGL_LIB_OPTION);
	      }
	    (mm->libFiles)->insert(-1,"libglu32");
	    (mm->libFiles)->insert(-1,"libopengl32");
	 }

      }
    else if (GetValue(rdbLib))		 	// Static Lib
      {
	// force mmaker to not generate the default all: target. We do it here.
      }
    else if (GetValue(rdbDLL))			// DLL
      {
      }
    mm->setLdFlags ( libraries.c_str() );

#endif		// WINDOWS WINDOWS WINDOWS

    return ans == M_OK;
  }

#ifdef V_VersionWindows
//====================>>> CNewProjMDlg::DialogDisplayed <<<====================
  void CNewProjMDlg::DialogDisplayed()
  {
    switch (((videApp*)theApp)->getCompiler())
      {
	case MinGW:
	    SetValue(rdbMing,1,Value);
	    break;
	case Cygwin:
	    SetValue(rdbCyg,1,Value);
	    break;
	case bcc:
	    SetValue(rdbBorland,1,Value);
	    break;
	default:
	    SetValue(rdbMing,1,Value);
	    break;
      }
  }

//====================>>> CNewProjMDlg::setBorlandValues <<<====================
  void CNewProjMDlg::setBorlandValues()
  {
    std::string libraries;
    std::string cFlags;

    // set up values used for Borland BCC 5.5

    mm->SetCC (BORLAND_COMPILER);
    cFlags  = "-q";		// c only flag

    (mm->libDirs)->insert (-1, "$(BCCROOT)\\lib");
    (mm->libDirs)->insert (-1, "$(BCCROOT)\\lib\\psdk");
    (mm->incDirs)->insert (-1, "$(BCCROOT)\\include");

    if (GetValue(rdbDbg))			// Debug version
      {
	cFlags  += " " BORLAND_DEBUG_FLAGS;		// debug flag
	libraries = BORLAND_DEBUG_FLAGS;	// linker, too
      }
    else					// Releae version
      {
	cFlags  += " " BORLAND_OPTIMIZE_FLAGS;	// optimize size flag
	libraries = "-v-";			// linker, too
      }

    if (!GetValue(chkV) && !GetValue(chkVdll))
	mm->SetHomeV ("");
    else
	mm->SetHomeV ("$(BCCROOT)");

    mm->SetDebugSwitches ("-jp");

    char textIn[maxFileNameSize + 1];
    GetTextIn(txiTgt, textIn, maxFileNameSize);
    std::string exeName = textIn;
    normalizePath (exeName);
    mm->SetExeName ( exeName.c_str() );

    (mm->defsPool)->insert (-1, BORLAND_DLL_DEFINE);

//#ifdef __BORLANDC__
//  #if __BORLANDC__ < 0x0560
    // needed only for BCB5 and earlier, or BCC32 5.5 and earlier
    (mm->defsPool)->insert (-1, "-D_WINVER=0x0400");
    (mm->defsPool)->insert (-1, "-D_WIN32_WINNT=0x0400");
    (mm->curDefs)->insert (-1, "-D_WINVER=0x0400");
    (mm->curDefs)->insert (-1, "-D_WIN32_WINNT=0x0400");
//  #endif
//#endif

    (mm->userTargets)->insert(-1,"# BCC32 DEF file: add after = if needed");
    (mm->userTargets)->insert(-1,"BCC32DEF =");
    (mm->userTargets)->insert(-1,"# BCC32 RT lib: cw32.lib static");
    (mm->userTargets)->insert(-1,"BCC32RTLIB = cw32");
    (mm->userTargets)->insert(-1,"# BCC32 Startup: c0x32.obj-console, c0w32.obj-winapi");
    if (GetValue(rdbCon))			// Console app
      {
	(mm->userTargets)->insert (-1,
				"BCC32STARTUP = " BORLAND_STARTUP_CONSOLE);
	//libraries += "-Tpe -ap -c -limport32 -l$(BCC32RTLIB)";	// win .exe, console, case
	libraries += " -Tpe -ap -c";	// win .exe, console, case
	(mm->libFiles)->insert(-1,"import32");
	(mm->libFiles)->insert(-1,"$(BCC32RTLIB)");
      }
    else if (GetValue(rdbGUI))			// GUI
      {
	(mm->userTargets)->insert (-1, "BCC32STARTUP = " BORLAND_STARTUP_GUI);
	libraries += " -Tpe -aa -c";	// win .exe, console, case
	// libraries += " -Tpe -aa -c -limport32 -l$(BCC32RTLIB)";	// win .exe, console, case
	(mm->libFiles)->insert(-1,"import32");
	(mm->libFiles)->insert(-1,"$(BCC32RTLIB)");

	if (GetValue(chkV))			// stuff for V
	  {
	    //libraries += " -lvguibcc -lcomctl32";
	    (mm->libFiles)->insert(-1,"vguibcc");
	    (mm->libFiles)->insert(-1,"comctl32");
	    (mm->libDirs)->insert(-1,"$(HOMEV)/lib");
	    (mm->incDirs)->insert(-1,"$(HOMEV)/include");
	  }
	if (GetValue(chkVdll))			// stuff for V
	  {
	    //libraries += " -lvguidbcc -lcomctl32";
	    (mm->libFiles)->insert(-1,"vguidbcc");
	    (mm->libFiles)->insert(-1,"comctl32");
	    (mm->libDirs)->insert(-1,"$(HOMEV)/lib");
	    (mm->incDirs)->insert(-1,"$(HOMEV)/include");
	    (mm->curDefs)->insert(-1,"-DUSE_V_DLL");
	    (mm->defsPool)->insert(-1,"-DUSE_V_DLL");
	  }

	if (GetValue(chkGL))			// use OpenGL
	 {
	    if (GetValue(chkV))
	      {
		// libraries += VGL_LIB_OPTION;
		(mm->libFiles)->insert(-1,"libVgl");
	      }
	    //libraries += OGL_LIB_OPTION;
	    (mm->libFiles)->insert(-1,"glu32");
	    (mm->libFiles)->insert(-1,"opengl32");
	 }
      }
    else if (GetValue(rdbLib))		 	// Static Lib
      {
      }
    else if (GetValue(rdbDLL))			// DLL
      {
      }

    mm->setLdFlags ( libraries.c_str() );
    mm->SetCFlags ( cFlags.c_str() );
  }
#endif

//====================>>> CNewProjMDlg::DialogCommand <<<====================
  void CNewProjMDlg::DialogCommand(ItemVal id, ItemVal retval, CmdType ctype)
  {
    UserDebug2(CmdEvents,"CNewProjMDlg::DialogCommand(id:%d, val:%d)\n",id, retval)

    switch (id)		// We will do some things depending on value
      {
#ifdef V_VersionWindows
	case chkV:
	    SetValue(chkVdll,0,Value);
	    break;
	case chkVdll:
	    SetValue(chkV,0,Value);
	    break;
#else
	case chkVMotif:
	    SetValue(chkVAthena,0,Value);
	    break;
	case chkVAthena:
	    SetValue(chkVMotif,0,Value);
	    break;
#endif
      }

    vModalDialog::DialogCommand(id,retval,ctype);
  }
