//=======================================================================
// VIDE project dialog
//	Version 2.00	date: 18 Mar 2003 12:09:56
//	cprojdlg.cpp:	Source for CprojectDialog class
//=======================================================================
#include<v/vapp.h>

#include "cprojdlg.h"
#include "videlib.h"
#include "TFileList.h"
using TEH::TFileNameList;
#include <v/vutil.h>
#include <v/vapp.h>
#include <v/vos.h>


//************************************************************************

//@V@:BeginIDs
  enum
    {
    frmTogBtns = 1000,
	tbtFiles, tbtFlags, tbtPaths, tbtDefs, tbtLibs, tbtOpts,

    frmMain,

    frmNames,
	lblExeName, txiExeName,lblMkfName,txiMkfName,
	lblCC, txiCC, lblCFlags, txiCFlags,
	lblLdFlags, txiLdFlags, lblHomev, txiHomev,

    frmSrc,
	lblObj, srcList, btnAddSrcFile, btnDelSrcFile,
	btnEditSrcFile, btnAddAllCPP, btnAddAllC, blk01,

    frmPaths,
	lblObjPath, txiObjPath, btnBrwObjD, lblBinPath,
	txiBinPath, lblSrcPath, txiSrcPath,  btnBrwSrcD,
	btnBrwBinD,

    frmLibsL,
	lblLibsL, libList, txtLibF, blk02,
	btnAddLibFile, btnDelLibFile, btnEditLibFile, btnBrowseLibFile,
	btnLibUp, btnLibDown,

    frmIncl,
	lblIncl, lstIncl, btnAddInclPath, btnDelInclPath,
	btnEditInclPath,

    frmLibs,
	lblLibP, lstLibsP, btnAddLibsPath, btnDelLibsPath,
	btnEditLibsPath,

    frmDefs,
	lblDefPool, lstDefPool, btnAddDef, btnDelDef, blkBlank1,
	blkBlank2, blkBlank3, btnAdd, btnDel, lblDef, lstDef,
	btnEditDef,

    frmOpts,
	lblCtagsArgs, txiCtagsArgs,
	lblDebugSwitches, txiDebugSwitches,

    frmUOpts,
	lblUOpt, UOptList, btnAddUOpt, btnDelUOpt, btnEditUOpt,

    frmUT,
	lblUTgt, UTgtList, btnAddUTgt, btnDelUTgt, btnEditUTgt,

    xyzzyLast

   };
//@V@:EndIds

//stub vector for listDialogs
 static char* vtmp[1] = { 0 };

//@V@:BeginDialogCmd PCmds
// define the dialog, which is a series of tabbed frames...
  static DialogCmd PCmds[] =
    {
      // This borderless frame makes the toggle buttons tightly spaced
	{C_Frame,frmTogBtns,0,"",NoList,CA_NoSpace | CA_NoBorder,isSens,NoFrame,0,0},
	{C_ToggleButton,tbtFlags,1,"Names",NoList, CA_None, isSens,
		frmTogBtns, 0, 0,0,"Set Names and Flags"},
	{C_ToggleButton,tbtFiles,0,"Files",NoList, CA_None, isSens,
		frmTogBtns, tbtFlags, 0, 0, "Set Source Files"},
	{C_ToggleButton,tbtPaths,0,"Paths",NoList, CA_None, isSens,
		frmTogBtns, tbtFiles, 0, 0,"Set various paths"},
	{C_ToggleButton,tbtLibs,0,"Libraries",NoList, CA_None, isSens,
		frmTogBtns, tbtPaths, 0,0, "Set Libraries"},
	{C_ToggleButton,tbtDefs,0,"Defines",NoList, CA_None, isSens,
		frmTogBtns, tbtLibs, 0,0, "Set Defines"},
	{C_ToggleButton,tbtOpts,0,"Advanced",NoList, CA_None, isSens,
		frmTogBtns, tbtDefs, 0, 0, "Advanced Makefile and Project Options"},

	// A Master frame to give uniform border to toggle frames
	{C_Frame,frmMain,0, "", NoList,CA_None,isSens,frmTogBtns,0,tbtFiles},

	// This is the default frame - on initially
	{C_ToggleFrame, frmNames, 1, "",NoList,CA_NoBorder,isSens, frmMain, 0, 0},

	{C_Label, lblExeName, 0," Target File Name:   ", NoList, CA_None, isSens,frmNames,0, 0},
	{C_TextIn, txiExeName, 0, " ", NoList, CA_Large, isSens,frmNames,lblExeName, 0,0,
		"Name of executable file"},

	{C_Label, lblMkfName, 0," Makefile Name:", NoList, CA_None, isSens,frmNames,0, txiExeName},
	{C_TextIn, txiMkfName, 0, " ", NoList, CA_Large, isSens,
		frmNames,lblExeName, txiExeName, 0, "Name of makefile"},

	{C_Label, lblCC, 0, " Compiler: ", NoList, CA_None, isSens,frmNames, 0, txiMkfName},
	{C_TextIn, txiCC, 0, " ", NoList, CA_Large, isSens, 
		frmNames,lblExeName, txiMkfName, 0,"Compiler name"},

	{C_Label, lblCFlags, 0," Compiler Flags: ", NoList, CA_Large, isSens,frmNames,0, txiCC},
	{C_TextIn, txiCFlags, 0, " ", NoList, CA_Large, isSens,
		frmNames,lblExeName, txiCC,0,"Compiler flags"},

	{C_Label, lblLdFlags, 0,  " Linker Flags: ", NoList, CA_Large, isSens,frmNames,0, txiCFlags},
	{C_TextIn, txiLdFlags, 0, " ", NoList, CA_Large, isSens,
		frmNames,lblExeName, txiCFlags,0,"Linker flags"},

	{C_Label, lblHomev, 0,  " HOMEV: ", NoList, CA_Large, isSens,frmNames,0, txiLdFlags},
	{C_TextIn, txiHomev, 0, " ", NoList, CA_Large, isSens,frmNames,lblExeName, txiLdFlags,0,"HOMEV"},

	{C_ToggleFrame, frmSrc, 0, "", NoList, CA_NoBorder | CA_Hidden, isSens, frmMain, 0, 0},

	{C_Label, lblObj, 0," Source Files:", NoList, CA_None, isSens, frmSrc,0, 0},
	{C_List, srcList, 180, " ", (void *) vtmp,
		CA_ListWidth | CA_Size, isSens, frmSrc,0, lblObj, 13, "List of source Files" },

	{C_Blank, blk01, 0, " ", NoList, CA_None, isSens,frmSrc, srcList, lblObj},

	{C_Button, btnAddAllCPP, 0, "Add *.cpp", NoList,CA_None, isSens,
		frmSrc, blk01, blk01, 0, "Add all source files with .cpp extension"},
	{C_Button, btnAddAllC, 0, "Add *.c  ", NoList,CA_None, isSens,
		frmSrc, blk01, btnAddAllCPP, 0, "Add all source files with .c extension"},

	{C_Button, btnAddSrcFile, 0, "Add", NoList,CA_None, isSens,
		frmSrc,0, srcList, 0, "Add source file with File Dialog"},
	{C_Button, btnDelSrcFile, 0, "Del", NoList,CA_None, isSens,
		frmSrc, btnAddSrcFile, srcList,0,"Delete selected file"},
	{C_Button, btnEditSrcFile, 0, "Edit", NoList,CA_None, isSens,
		frmSrc, btnDelSrcFile, srcList,0,"Edit selected file"},


	{C_ToggleFrame, frmPaths, 0, "",NoList,CA_NoBorder | CA_Hidden,isSens,frmMain, 0, 0},
#ifdef XXXXX
//	{C_Label, lblSrcPath, 0, " Src path: ", NoList, CA_None, isSens,frmPaths,0, 0},
//	{C_TextIn, txiSrcPath, 0, " ", NoList, CA_Large, isSens,frmPaths, lblSrcPath, 0,0,
//		"Path for source files"},
//	{C_Button, btnBrwSrcD, 0, " Browse ", NoFrame,CA_None, isSens,frmPaths,txiSrcPath, 0, 0,
//		"Select with File Dialog"},
#endif

	{C_Label, lblObjPath, 0, " Obj path: ", NoList, CA_None, isSens,frmPaths,0, 0},
	{C_TextIn, txiObjPath, 0, " ", NoList, CA_Large, isSens,frmPaths, lblObjPath, 0,0,
		"Path to write obj files"},
	{C_Button, btnBrwObjD, 0, " Browse ", NoFrame,CA_None, isSens,frmPaths,txiObjPath, 0, 0,
		"Select with File Dialog"},

	{C_Label, lblBinPath, 0, " Bin path: ", NoList, CA_None, isSens,frmPaths, 0, txiObjPath},
	{C_TextIn, txiBinPath, 0, " ", NoList, CA_Large, isSens,frmPaths,lblBinPath, txiObjPath,0,
		"Path to write exectuable"},
	{C_Button, btnBrwBinD, 0, " Browse ", NoFrame,CA_None, isSens,frmPaths,txiBinPath, txiObjPath,0,
		"Select with File Dialog"},

	{C_Frame, frmIncl, 0, "", NoList, CA_None, isSens, frmPaths, 0, txiBinPath},
	{C_Label, lblIncl, 0, "Include Paths:", NoList, CA_None, isSens, frmIncl,0, 0},
	{C_List,  lstIncl, 130, " ",  ( void * ) vtmp, CA_ListWidth, isSens,
		frmIncl,0, lblIncl,0,"Paths to search for includes"},
	{C_Button, btnAddInclPath, 0, "Add", NoFrame,CA_None, isSens,
		frmIncl,0, lstIncl,0,"Add path with file dialog"},
	{C_Button, btnDelInclPath, 0, "Del", NoFrame,CA_None, isSens,
		frmIncl, btnAddInclPath, lstIncl,0,"Delete selected path"},
	{C_Button, btnEditInclPath, 0, "Edit", NoList,CA_None, isSens,
		frmIncl, btnDelInclPath, lstIncl,0,"Edit selected item"},

	{C_Frame, frmLibs, 0, "", NoList, CA_None, isSens, frmPaths, frmIncl, txiBinPath},
	{C_Label, lblLibP, 0, "Library Paths:", NoList, CA_None, isSens, frmLibs,0, 0},
	{C_List,  lstLibsP, 130, " ",  (void * ) vtmp, CA_ListWidth, isSens,
		frmLibs,0, lblLibP,0,"Paths for libraries"},
	{C_Button, btnAddLibsPath, 0, "Add", NoFrame,CA_None, isSens,
		frmLibs,0, lstLibsP,0,"Add path with File Dialog"},
	{C_Button, btnDelLibsPath, 0, "Del", NoFrame,CA_None, isSens,
		frmLibs, btnAddLibsPath, lstLibsP,0,"Delete selected path"},
	{C_Button, btnEditLibsPath, 0, "Edit", NoList,CA_None, isSens,
		frmLibs, btnDelLibsPath, lstLibsP,0,"Edit selected item"},

	{C_ToggleFrame, frmLibsL, 0, "", NoList, CA_NoBorder | CA_Hidden, isSens, frmMain, 0, 0},

	{C_Label, lblLibsL, 0," Library Files:", NoList, CA_None, isSens, frmLibsL,0, 0},
	{C_List, libList, 160, " ", (void *) vtmp,
		CA_ListWidth | CA_Size, isSens, frmLibsL,0, lblLibsL, 12, "List of library Files" },


	{C_Button, btnAddLibFile, 0, "Add", NoList,CA_None, isSens,
		frmLibsL,0, libList, 0, "Add library file with File Dialog"},
	{C_Button, btnDelLibFile, 0, "Del", NoList,CA_None, isSens,
		frmLibsL, btnAddLibFile, libList,0,"Delete selected file"},
	{C_Button, btnEditLibFile, 0, "Edit", NoList,CA_None, isSens,
		frmLibsL, btnDelLibFile, libList,0,"Edit selected file"},
	{C_Button, btnBrowseLibFile, 0, "Add by Browsing", NoList,CA_None, isSens,
		frmLibsL, btnEditLibFile, libList,0,"Add lib file by browsing"},
	{C_Blank, blk02, 0, " ", NoList, CA_None, isSens,frmLibsL, libList, lblLibsL},
	{C_Text, txtLibF, 0, "", (void *)
                "IMPORTANT: After you\n"
		"add a library, you must\n"
		"also add its PATH in the\n"
		"Paths tab if it is not a\n"
		"system library."
                ,CA_NoBorder,isSens,frmLibsL, blk02,lblLibsL },
	{C_Button, btnLibUp, 0, " Move Up ", NoList,CA_None, isSens,
		frmLibsL, blk02, txtLibF,0,"Move lib file up one"},
	{C_Button, btnLibDown, 0, "Move Down", NoList,CA_None, isSens,
		frmLibsL, blk02, btnLibUp,0,"Move lib file down one"},


	{C_ToggleFrame, frmDefs, 0, "",NoList,CA_NoBorder | CA_Hidden,isSens,frmMain, 0, 0},
	{C_Label, lblDefPool, 0, " Definition Pool", NoList, CA_None, isSens,frmDefs,0, 0},
	{C_List,  lstDefPool, 124, " ",  (void *) vtmp,  CA_ListWidth | CA_Size, isSens,
		frmDefs, 0, lblDefPool, 12,"Defines available, but not used" },
	{C_Button, btnAddDef, 0, "Add", NoFrame,CA_None, isSens,
		frmDefs, 0, lstDefPool,0,"Add define to pool"},
	{C_Button, btnDelDef, 0, "Del", NoFrame,CA_None, isSens,
		frmDefs, btnAddDef, lstDefPool,0,"Delete selected define"},
	{C_Button, btnEditDef, 0, "Edit", NoList,CA_None, isSens,
		frmDefs, btnDelDef, lstDefPool,0,"Edit selected item"},

	{C_Blank, blkBlank1, 0, " ", NoList, CA_None, isSens,frmDefs,lstDefPool, 0},
	{C_Blank, blkBlank2, 0, " ", NoList, CA_None, isSens,frmDefs,lstDefPool, blkBlank1},
	{C_Blank, blkBlank3, 0, " ", NoList, CA_None, isSens,frmDefs,lstDefPool, blkBlank2},
	{C_Button, btnAdd, 0,   ">", NoFrame,CA_None, isSens,
		frmDefs, lstDefPool, blkBlank3,0,"Add to active defines"},

	{C_Label, lblDef, 0, " Active Definitions ", NoList, CA_None, isSens,
		frmDefs, btnAdd, 0},
	{C_List,  lstDef, 124, " ",  (void *)vtmp, CA_ListWidth| CA_Size, isSens,
		frmDefs,btnAdd, lblDef, 12,"Defines used to build makefile"},
	{C_Button, btnDel, 0,   "Del", NoFrame,CA_None, isSens,
		frmDefs, btnAdd, lstDef,0,"Delete from active defines"},

	{C_ToggleFrame, frmOpts, 0, "",NoList,CA_NoBorder | CA_Hidden,isSens,frmMain, 0, 0},

	{C_Label, lblCtagsArgs, 0, "ctags args: ", NoList, CA_None, isSens,frmOpts,0, 0},
	{C_TextIn, txiCtagsArgs, 0, " ", NoList, CA_Large, isSens,frmOpts,
		lblCtagsArgs,0,0,"Project ctags args - overrides VIDE default ctags args"},

	{C_Label, lblDebugSwitches, 0, "debug args:", NoList, CA_None, isSens,frmOpts,0, txiCtagsArgs},
	{C_TextIn, txiDebugSwitches, 0, " ", NoList, CA_Large, isSens,frmOpts,
		lblCtagsArgs,txiCtagsArgs,0,"Additional arguments passed to debugger"},


	{C_Frame, frmUOpts, 0, "",NoList,CA_None,isSens,frmOpts, 0, txiDebugSwitches},
	{C_Label, lblUOpt, 0," User Makefile Options:", NoList, CA_None, isSens, frmUOpts,0, 0},
	{C_List, UOptList, 130, " ", (void *) vtmp, CA_ListWidth, isSens,
		frmUOpts, 0, lblUOpt, 0, "Options included in Makefile" },
	{C_Button, btnAddUOpt, 0, "Add", NoList,CA_None, isSens,
		frmUOpts,0, UOptList, 0, "Add User Option"},
	{C_Button, btnDelUOpt, 0, "Del", NoList,CA_None, isSens,
		frmUOpts, btnAddUOpt, UOptList,0,"Delete selected item"},
	{C_Button, btnEditUOpt, 0, "Edit", NoList,CA_None, isSens,
		frmUOpts, btnDelUOpt, UOptList,0,"Edit selected item"},

	{C_Frame, frmUT, 0, "",NoList,CA_None, isSens,frmOpts, frmUOpts, txiDebugSwitches},
	{C_Label, lblUTgt, 0," User Target Options:", NoList, CA_None, isSens, frmUT,0, 0},
	{C_List, UTgtList, 130, " ", (void *) vtmp, CA_ListWidth, isSens,
		frmUT, 0, lblUTgt, 0, "User defined targets for Makefile" },
	{C_Button, btnAddUTgt, 0, "Add", NoList,CA_None, isSens,
		frmUT,0, UTgtList, 0, "Add User Target"},
	{C_Button, btnDelUTgt, 0, "Del", NoList,CA_None, isSens,
		frmUT, btnAddUTgt, UTgtList,0,"Delete selected item"},
	{C_Button, btnEditUTgt, 0, "Edit", NoList,CA_None, isSens,
		frmUT, btnDelUTgt, UTgtList,0,"Edit selected item"},

	{C_Button, M_OK, 0, "   OK   ", NoList, CA_DefaultButton, isSens,
		NoFrame, 0, frmTogBtns,0,"Save project file"},

//	{C_Button, M_Cancel, 0, " Cancel ",NoList,CA_None, isSens,
//		NoFrame, M_OK, frmTogBtns,0,"Abort Project Edit"},

	{C_EndOfList,0,0,0,0,CA_None,0,0,0}
      };
//@V@:EndDialogCmd

//===================>>> projectDialog::projectDialog <<<====================
  projectDialog::projectDialog(makefileMaker* m,
	vBaseWindow* bw, char* title)
	: vModalDialog(bw, title)
  {
    mm = m;
    cmdw = (videCmdWindow*) bw;
    ta = 0;
    AddDialogCmds(PCmds);
  }

//===================>>> projectDialog::projectDialog <<<=====================
  projectDialog::projectDialog(makefileMaker* m, vApp *aw, char* title)
    : vModalDialog(aw, title)
  {
   mm = m;
   ta = 0;
   AddDialogCmds(PCmds);
  }

//===================>>> projectDialog::~projectDialog <<<====================
  projectDialog::~projectDialog()
  {
    //IMPORTANT: set srcList back to original status!
    //has to be fixed in a new cmdList version

    PCmds[vGetcmdIdIndex(srcList, PCmds)].itemList = (void * ) vtmp;
    SetValue(srcList,-1,ChangeListPtr);

    PCmds[vGetcmdIdIndex(libList, PCmds)].itemList = (void * ) vtmp;
    SetValue(srcList,-1,ChangeListPtr);

    PCmds[vGetcmdIdIndex(lstIncl, PCmds)].itemList = (void * ) vtmp;
    SetValue(lstIncl,-1,ChangeListPtr);

    PCmds[vGetcmdIdIndex(lstLibsP, PCmds)].itemList = (void * ) vtmp;
    SetValue(lstLibsP,-1,ChangeListPtr);

    PCmds[vGetcmdIdIndex(lstDefPool, PCmds)].itemList = (void * ) vtmp;
    SetValue(lstDefPool,-1,ChangeListPtr);

    PCmds[vGetcmdIdIndex(lstDef, PCmds)].itemList = (void * ) vtmp;
    SetValue(lstDef,-1,ChangeListPtr);

    PCmds[vGetcmdIdIndex(UOptList, PCmds)].itemList = (void * ) vtmp;
    SetValue(UOptList,-1,ChangeListPtr);

    PCmds[vGetcmdIdIndex(UTgtList, PCmds)].itemList = (void * ) vtmp;
    SetValue(UTgtList,-1,ChangeListPtr);
  }

//====================>>> projectDialog::DialogDisplayed <<<====================
  void projectDialog::DialogDisplayed()
  {

    // Display only the top frame

    SetValue(frmNames, 1, Value);	SetValue(frmSrc, 0, Value);
    SetValue(frmPaths, 0, Value);	SetValue(frmDefs, 0, Value);
    SetValue(frmOpts, 0, Value);	SetValue(frmLibsL, 0, Value);

    // set dialog values to the ones from the mm object

    SetString(txiExeName, mm->GetExeName().c_str() );
    SetString(txiMkfName, mm->GetMakefileName().c_str() );
    SetString(txiCC, mm->GetCC().c_str() );
    SetString(txiCFlags, mm->GetCFlags().c_str() );
    SetString(txiLdFlags, mm->getLdFlags().c_str() );
    SetString(txiHomev, mm->GetHomeV().c_str() );
    SetString(txiObjPath, mm->GetObjDir().c_str() );
    SetString(txiBinPath, mm->GetBinDir().c_str() );
    SetString(txiCtagsArgs, mm->GetCtags().c_str() );
    SetString(txiDebugSwitches, mm->GetDebugSwitches().c_str() );


    // set to current lists
    PCmds[vGetcmdIdIndex(lstIncl, PCmds)].itemList =
	(void *)((mm->incDirs)->list);
    SetValue(lstIncl,-1,ChangeListPtr);	// change the whole list & unselect!

    PCmds[vGetcmdIdIndex(srcList, PCmds)].itemList =
	(void *)(mm->srcFiles)->list;
    SetValue(srcList,-1,ChangeListPtr);	// change the whole list!

    PCmds[vGetcmdIdIndex(libList, PCmds)].itemList =
	(void *)(mm->libFiles)->list;
    SetValue(libList,-1,ChangeListPtr);	// change the whole list!

    PCmds[vGetcmdIdIndex(lstLibsP, PCmds)].itemList =
	(void *)((mm->libDirs)->list);
    SetValue(lstLibsP,-1,ChangeListPtr);	// change the whole list & unselect!

    PCmds[vGetcmdIdIndex(lstDefPool, PCmds)].itemList =
    	(void *)(mm->defsPool)->list;
    SetValue(lstDefPool, -1, ChangeListPtr); // change whole list & unselect!

    PCmds[vGetcmdIdIndex(lstDef, PCmds)].itemList =
    	(void *)(mm->curDefs)->list;
    SetValue(lstDef,-1,ChangeListPtr);	// change the whole list & unselect!

    PCmds[vGetcmdIdIndex(UOptList, PCmds)].itemList =
    	(void *)(mm->curOpts)->list;
    SetValue(UOptList,-1,ChangeListPtr);	// change whole list & unselect!

    PCmds[vGetcmdIdIndex(UTgtList, PCmds)].itemList =
    	(void *)(mm->userTargets)->list;
    SetValue(UTgtList,-1,ChangeListPtr);	// change whole list & unselect!
  }

//====================>>> projectDialog::editProject <<<====================
  int projectDialog::editProject()
  {
    ItemVal dans, rval;
    dans = ShowModalDialog("C++ Project Editor",rval);
    if (dans == M_Cancel)
	return Cancel;

    // OK, we have to see if anything changed...
    short const maxInputChars = 1023;
    char textIn[maxInputChars + 1];		// input buffer
    *textIn = NULL_CHAR;
    GetTextIn (txiExeName, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetExeName().c_str() ) != 0)
	mm->SetExeName ( textIn );

    GetTextIn(txiCC, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetCC().c_str() ) != 0)
	mm->SetCC ( textIn );

    GetTextIn (txiCFlags, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetCFlags().c_str() ) != 0)
	mm->SetCFlags ( textIn );

    GetTextIn (txiLdFlags, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->getLdFlags().c_str() ) != 0)
	mm->setLdFlags ( textIn );

    GetTextIn (txiHomev, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetHomeV().c_str() ) != 0)
	mm->SetHomeV ( textIn );

    GetTextIn (txiObjPath, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetObjDir().c_str() ) != 0)
	mm->SetObjDir ( textIn );

    GetTextIn (txiBinPath, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetBinDir().c_str() ) != 0)
	mm->SetBinDir ( textIn );

    GetTextIn (txiCtagsArgs, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetCtags().c_str() ) != 0)
	mm->SetCtags ( textIn );

    GetTextIn (txiDebugSwitches, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetDebugSwitches().c_str() ) != 0)
	mm->SetDebugSwitches ( textIn );

    GetTextIn (txiMkfName, textIn, maxInputChars);
    if ( strcmp ( textIn, mm->GetMakefileName().c_str() ) != 0)
	mm->SetMakefileName ( textIn );

    return NoBuild;
  }

//====================>>> projectDialog::DialogCommand <<<====================
  void projectDialog::DialogCommand(ItemVal id, ItemVal retval, CmdType ctype)
  {
    UserDebug2(CmdEvents,"projectDialog::DialogCommand(id:%d, val:%d)\n",id, retval)

    switch (id)		// We will do some things depending on value
      {

	case tbtFiles:
	  {
	    SetValue(tbtFiles,1,Value);		SetValue(tbtFlags,0,Value);
	    SetValue(tbtPaths,0,Value);		SetValue(tbtDefs,0,Value);
	    SetValue(tbtOpts,0,Value);		SetValue(tbtLibs,0,Value);

	    SetValue(frmNames, 0, Value);	SetValue(frmSrc, 1, Value);
	    SetValue(frmPaths, 0, Value);	SetValue(frmDefs, 0, Value);
	    SetValue(frmOpts, 0, Value);	SetValue(frmLibsL, 0, Value);
	    break;
	  }

	case tbtFlags:
	  {
	    SetValue(tbtFiles,0,Value);		SetValue(tbtFlags,1,Value);
	    SetValue(tbtPaths,0,Value);		SetValue(tbtDefs,0,Value);
	    SetValue(tbtOpts,0,Value);		SetValue(tbtLibs,0,Value);

	    SetValue(frmNames, 1, Value);	SetValue(frmSrc, 0, Value);
	    SetValue(frmPaths, 0, Value);	SetValue(frmDefs, 0, Value);
	    SetValue(frmOpts, 0, Value);	SetValue(frmLibsL, 0, Value);
	    break;
	  }

	case tbtPaths:
	  {
	    SetValue(tbtFiles,0,Value);		SetValue(tbtFlags,0,Value);
	    SetValue(tbtPaths,1,Value);		SetValue(tbtDefs,0,Value);
	    SetValue(tbtOpts,0,Value);		SetValue(tbtLibs,0,Value);

	    SetValue(frmNames, 0, Value);	SetValue(frmSrc, 0, Value);
	    SetValue(frmPaths, 1, Value);	SetValue(frmDefs, 0, Value);
	    SetValue(frmOpts, 0, Value);	SetValue(frmLibsL, 0, Value);
	    break;
	  }

	case tbtDefs:
	  {
	    SetValue(tbtFiles,0,Value);		SetValue(tbtFlags,0,Value);
	    SetValue(tbtPaths,0,Value);		SetValue(tbtDefs,1,Value);
	    SetValue(tbtOpts,0,Value);		SetValue(tbtLibs,0,Value);

	    SetValue(frmNames, 0, Value);	SetValue(frmSrc, 0, Value);
	    SetValue(frmPaths, 0, Value);	SetValue(frmDefs, 1, Value);
	    SetValue(frmOpts, 0, Value);	SetValue(frmLibsL, 0, Value);
	    break;
	  }

	case tbtOpts:
	  {
	    SetValue(tbtFiles,0,Value);		SetValue(tbtFlags,0,Value);
	    SetValue(tbtPaths,0,Value);		SetValue(tbtDefs, 0,Value);
	    SetValue(tbtOpts,1,Value);		SetValue(tbtLibs,0,Value);

	    SetValue(frmNames, 0, Value);	SetValue(frmSrc, 0, Value);
	    SetValue(frmPaths, 0, Value);	SetValue(frmDefs, 0, Value);
	    SetValue(frmOpts, 1, Value);	SetValue(frmLibsL, 0, Value);
	    break;
	  }

	case tbtLibs:
	  {
	    SetValue(tbtFiles,0,Value);		SetValue(tbtFlags,0,Value);
	    SetValue(tbtPaths,0,Value);		SetValue(tbtDefs, 0,Value);
	    SetValue(tbtOpts,0,Value);		SetValue(tbtLibs,1,Value);

	    SetValue(frmNames, 0, Value);	SetValue(frmSrc, 0, Value);
	    SetValue(frmPaths, 0, Value);	SetValue(frmDefs, 0, Value);
	    SetValue(frmOpts, 0, Value);	SetValue(frmLibsL, 1, Value);
	    break;
	  }

	case btnAddSrcFile:
	  {
	    char MSDOSpath[maxFileNameSize + 1];
	    *MSDOSpath = NULL_CHAR;
	    int fi = 0;
	    static char* makeFilter[] = { SRC_FILE_FILTER ";*.rc", "*.*", 0 };
	    // initial directory to open to
	    vFileSelect fsel(this);
	    int oans = fsel.FileSelect("Add a Source File",
				MSDOSpath, maxFileNameSize,
				makeFilter, fi);
	    if (oans && *MSDOSpath) //filename picked
	      {
		ta=1; // target file added!
		char uxfn[maxFileNameSize];
		*uxfn = NULL_CHAR;
		Dos2UxFName(MSDOSpath, uxfn, 0);
		if (!mm->addFile(uxfn))
		  {
		    vNoticeDialog note(this);
		    note.Notice("File already selected for this Project");
		  }
	      }
	    SetValue(srcList,-1,ChangeList); // update list & unselect!
	    SetValue(lstIncl,-1,ChangeListPtr); //update list & unselect!
	    break;
	  }	//@V@:EndCase

	case btnAddAllCPP:
	case btnAddAllC:
	  {
	    // build a file name mask to search for
	    // starting in the source directory.
	    // To Do: Spin this off to a separate function to build the list
	    // from repeat masks, using the same filter list of C or CPP files
	    // as is used elsewhere (e.g., "*.cpp;*.cxx;*.cc;*.CC")
	    std::string mask = ".";
	    if (id == btnAddAllCPP)
		mask += PATH_SEPARATOR_STR "*.cpp";
	    else
		mask += PATH_SEPARATOR_STR "*.c";
#ifdef V_VersionWindows
	    ::fixBackSlash (mask);
#else
	    ::fixSlash (mask);
#endif

	    // get the list of file names
	    TFileNameList fileList (mask.c_str(), TFileNameList::FLT_Normal);
	    char const * const * theList = fileList.GetList();

	    if ( fileList.IsEmpty() )
	    {
		vNoticeDialog note(this);
		note.Notice("No files added.");
		break;
	    }

	    for (int ix = 0 ; theList[ix] != NULL ; ++ix)
	      {
		char uxfn[maxFileNameSize];
		*uxfn = NULL_CHAR;
		Dos2UxFName(theList[ix], uxfn, 0);
		(void) mm->addFile(uxfn);
	      }
	    SetValue(srcList,-1,ChangeList); // update list & unselect!
	    SetValue(lstIncl,-1,ChangeListPtr); //update list & unselect!

	    break;
	  }

	case btnDelSrcFile:
	  {
	    int lval = GetValue(srcList);
	    if (lval < 0)
		break;
	    (mm->srcFiles)->deleteItem(lval);
	    SetValue(srcList,-1,ChangeList); // update list & unselect!
	    mm->changed = true;

	  }	//@V@:EndCase

	case btnEditSrcFile:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[maxFileNameSize + 1];
	    *r = NULL_CHAR;

	    int lval = GetValue(srcList);
	    if (lval < 0)
		break;

	    ans = newDefDlg.Reply("Edit Source filename", r, maxFileNameSize,
		(mm->srcFiles)->list[lval]);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->srcFiles)->replace(lval,r);
	      }
	    SetValue(srcList,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnBrwSrcD:
	  {
	    char MSDOSpath[maxFileNameSize + 1];
	    *MSDOSpath = NULL_CHAR;
	    int fi = 0;
#ifdef V_VersionX
	    static char* makeFilter[] = {SRC_FILE_FILTER, "*", 0};
#else
	    static char* makeFilter[] = {SRC_FILE_FILTER, "*.*", 0};
#endif
	    vFileSelect fsel(this);

	    fsel.FileSelect("Select a file in the Src Directory",
			MSDOSpath, maxFileNameSize, makeFilter, fi);
	    char uxfn[maxFileNameSize];
	    *uxfn = NULL_CHAR;
	    Dos2UxFName(MSDOSpath, uxfn, 1);
	    SetString(txiSrcPath, uxfn);
	    mm->changed = true;
	    break;
	  }

	case btnBrwObjD:
	  {
	    char MSDOSpath[maxFileNameSize + 1];
	    *MSDOSpath = NULL_CHAR;
	    int fi = 0;
#ifdef V_VersionX
	    static char* makeFilter[] = {"*.o", "*", 0};
#else
	    static char* makeFilter[] = {"*.o;*.obj", "*.*", 0};
#endif
	    vFileSelect fsel(this);

	    fsel.FileSelect("Select a file in the Obj Directory",
			MSDOSpath, maxFileNameSize, makeFilter,fi);
	    char uxfn[maxFileNameSize];
	    *uxfn = NULL_CHAR;
	    Dos2UxFName(MSDOSpath, uxfn, 1);
	    SetString(txiObjPath, uxfn);
	    mm->changed = true;
	    break;
	  }

	case btnBrwBinD:
	  {
	    char MSDOSpath[maxFileNameSize + 1];
	    *MSDOSpath = NULL_CHAR;
	    int fi = 0;
#ifdef V_VersionX
	    static char* makeFilter[] = {"*", 0};
#else
	    static char* makeFilter[] = {"*.exe", "*.*", 0};
#endif
	    vFileSelect fsel(this);

	    fsel.FileSelect("Select file in Bin Directory",
			MSDOSpath, maxFileNameSize, makeFilter,fi);
	    char uxfn[maxFileNameSize];
	    *uxfn = NULL_CHAR;
	    Dos2UxFName(MSDOSpath, uxfn, 1);
	    SetString(txiBinPath, uxfn);
	    mm->changed = true;
	    break;
	  }

//@@@
	case btnLibUp:
	  {
	    int lval = GetValue(libList);
	    if (lval <= 0)
		break;
	    int res = (mm->libFiles)->swapUp(lval);
	    if (res >= 0)
	      {
		SetValue(libList,-1,ChangeList); // update list & unselect!
		SetValue(libList,lval-1,Value); // update list & unselect!
	      }
	    mm->changed = true;
	    break;
	  }

	case btnLibDown:
	  {
	    int lval = GetValue(libList);
	    if (lval < 0)
		break;
	    int res = (mm->libFiles)->swapDown(lval);
	    if (res >= 0)
	      {
		SetValue(libList,-1,ChangeList); // update list & unselect!
		SetValue(libList,lval+1,Value); // update list & unselect!
	      }
	    mm->changed = true;
	    break;
	  }

	case btnAddLibFile:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[maxFileNameSize + 1];
	    *r = NULL_CHAR;
	    ans = newDefDlg.Reply("Add Library name", r, maxFileNameSize);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		if (!mm->addLibFile(r))
		  {
		    vNoticeDialog note(this);
		    note.Notice("Library already selected for this Project");
		  }
	      }
	    SetValue(libList,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnBrowseLibFile:
	  {
	    char lpath[maxFileNameSize + 1];
	    *lpath = NULL_CHAR;
	    int fi = 0;
	    static char* makeFilter[] = {"*.a;*.lib", "*.*", 0 };
	    // initial directory to open to
	    vFileSelect fsel(this);
	    int oans = fsel.FileSelect("Add a library",
				lpath, maxFileNameSize,
				makeFilter, fi);
	    if (oans && *lpath) //filename picked
	      {
		ta=1; // target file added!
		if (!mm->addLibFile(lpath))
		  {
		    vNoticeDialog note(this);
		    note.Notice("Library already selected for this Project");
		  }
	      }
	    SetValue(libList,-1,ChangeList); // update list & unselect!
	    break;
	  }	//@V@:EndCase

	case btnDelLibFile:
	  {
	    int lval = GetValue(libList);
	    if (lval < 0)
		break;
	    (mm->libFiles)->deleteItem(lval);
	    SetValue(libList,-1,ChangeList); // update list & unselect!
	    mm->changed = true;

	  }	//@V@:EndCase

	case btnEditLibFile:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[maxFileNameSize + 1];
	    *r = NULL_CHAR;

	    int lval = GetValue(libList);
	    if (lval < 0)
		break;

	    ans = newDefDlg.Reply("Edit Library name", r, maxFileNameSize,
		(mm->libFiles)->list[lval]);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->libFiles)->replace(lval,r);
	      }
	    SetValue(libList,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnAddInclPath:
	  {

	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[maxFileNameSize + 1];
	    *r = NULL_CHAR;

	    ans = newDefDlg.Reply("Add Include Path :", r, maxFileNameSize);
	    if (ans == M_Cancel)
		 break;

	    if (*r)
	      {
		if (!mm->addInclude(r))
		  {
		    vNoticeDialog note(this);
		    note.Notice("Path already added for this Project");
		  }
	      }
	    SetValue(lstIncl,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;

	    break;
	  }	//@V@:EndCase

	case btnDelInclPath:
	  {
	    int lval=GetValue(lstIncl);
	    if (lval < 0)
		break;
	    (mm->incDirs)->deleteItem(lval);
	    SetValue(lstIncl,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }	//@V@:EndCase

	case btnEditInclPath:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[maxFileNameSize + 1];
	    *r = NULL_CHAR;

	    int lval = GetValue(lstIncl);
	    if (lval < 0)
		break;

	    ans = newDefDlg.Reply("Edit Include Path", r, maxFileNameSize,
		(mm->incDirs)->list[lval]);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->incDirs)->replace(lval,r);
	      }
	    SetValue(lstIncl,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnAddLibsPath:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[maxFileNameSize + 1];
	    *r = NULL_CHAR;

	    ans = newDefDlg.Reply("Add Lib Path :", r, maxFileNameSize);
	    if (ans == M_Cancel)
		 break;

	    if (*r)
	      {
		char uxfn[maxFileNameSize];
		*uxfn = NULL_CHAR;
		Dos2UxFName(r, uxfn, 0);

		(mm->libDirs)->insert(-1,uxfn);
		SetValue(lstLibsP,-1,ChangeListPtr); // update list & unselect!
	      }
	    SetValue(lstLibsP,-1,ChangeListPtr); // update list & unselect!
	    mm->changed = true;
	    break;
	  }	//@V@:EndCase

	case btnDelLibsPath:
	  {
	    int lval=GetValue(lstLibsP);
	    if (lval < 0)
		break;
	    (mm->libDirs)->deleteItem(lval);
	    SetValue(lstLibsP,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }	//@V@:EndCase

	case btnEditLibsPath:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[maxFileNameSize + 1];
	    *r = NULL_CHAR;

	    int lval = GetValue(lstLibsP);
	    if (lval < 0)
		break;

	    ans = newDefDlg.Reply("Edit Lib Path", r, maxFileNameSize,
		(mm->libDirs)->list[lval]);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->libDirs)->replace(lval,r);
	      }
	    SetValue(lstLibsP,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	  case btnAddDef:
	    {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[256];

	    ans = newDefDlg.Reply("Enter define/undefine (including -D or -U):", r, 255);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->defsPool)->insert(-1,r);
	      }
	    SetValue(lstDefPool,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }


	case btnDelDef:
	  {
	    int lval = GetValue(lstDefPool);
	    if (lval < 0)
		break;
	    (mm->defsPool)->deleteItem(lval);
	    SetValue(lstDefPool,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  } //@V@:EndCase


	case btnEditDef:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[256];

	    int lval = GetValue(lstDefPool);
	    if (lval < 0)
		break;

	    ans = newDefDlg.Reply("Edit Definition", r, 255,
		(mm->defsPool)->list[lval]);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->defsPool)->replace(lval,r);
	      }
	    SetValue(lstDefPool,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnAdd:		// add to def pool
	    {
	    int lval=GetValue(lstDefPool);
	    if (lval < 0)
		break;
	    (mm->curDefs)->insert(-1,(mm->defsPool)->list[lval]);	// add to def list
	    SetValue(lstDef,-1,ChangeListPtr); //update list & unselect!
	    SetValue(lstDefPool,-1,ChangeListPtr); // unselect!
	    mm->changed = true;
	    break;
	    }	//@V@:EndCase

	case btnDel:		// delete from active defs
	    {
	    int lval=GetValue(lstDef);
	    if (lval < 0)
		break;
	    (mm->curDefs)->deleteItem(lval);	// add to def list
	    SetValue(lstDef, -1, ChangeListPtr); //update list & unselect!
	    mm->changed = true;

	    break;
	    }	//@V@:EndCase

	case btnAddUOpt:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[256];

	    ans = newDefDlg.Reply("Enter Makefile user define:", r, 255);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->curOpts)->insert(-1,r);
	      }
	    SetValue(UOptList,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnDelUOpt:
	  {
	    int lval=GetValue(UOptList);
	    if (lval < 0)
		break;
	    (mm->curOpts)->deleteItem(lval);	// add to def list
	    SetValue(UOptList, -1, ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnEditUOpt:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[256];

	    int lval = GetValue(UOptList);
	    if (lval < 0)
		break;

	    ans = newDefDlg.Reply("Edit User Makefile definition", r, 255,
		(mm->curOpts)->list[lval]);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->curOpts)->replace(lval,r);
	      }
	    SetValue(UOptList,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnAddUTgt:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[256];

	    ans = newDefDlg.Reply("Enter Makefile user define:", r, 255);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->userTargets)->insert(-1,r);
	      }
	    SetValue(UTgtList,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnDelUTgt:
	  {
	    int lval=GetValue(UTgtList);
	    if (lval < 0)
		break;
	    (mm->userTargets)->deleteItem(lval);	// add to def list
	    SetValue(UTgtList, -1, ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

	case btnEditUTgt:
	  {
	    vReplyDialog newDefDlg(this);
	    int ans;
	    char r[256];

	    int lval = GetValue(UTgtList);
	    if (lval < 0)
		break;

	    ans = newDefDlg.Reply("Edit User Makefile target", r, 255,
		(mm->userTargets)->list[lval]);
	    if (ans == M_Cancel)
		 break;
	    if (*r)
	      {
		(mm->userTargets)->replace(lval,r);
	      }
	    SetValue(UTgtList,-1,ChangeListPtr); //update list & unselect!
	    mm->changed = true;
	    break;
	  }

      }//switch

    vModalDialog::DialogCommand(id,retval,ctype);
  }

//------------------------------------------------------------------------
