//=======================================================================
//	videcnv.h:	Header for vedCanvasPane class
//	Version 2.00	date: 17 Mar 2003 11:26:50
//=======================================================================

#ifndef VIDECNV_H
#define VIDECNV_H

#define VCmdWindow videCmdWindow

#include <v/vtexted.h>
#include <v/vpopmenu.h>

#include <string>
using std::string;

#include <fstream>
using std::ifstream;
using std::ofstream;

    class VCmdWindow;

    class vedTextEditor : public vTextEditor
      {
      public:		//---------------------------------------- public
	vedTextEditor(VCmdWindow* parent);
	virtual ~vedTextEditor();

	int ReadFile(const char* fn, int paintIt = 1);
	int SaveFile(const string sname) { return SaveFile((const char*)sname.c_str());}
	int SaveFile(const char* name);
	void PrintFile(const char* name);
	void clearChanges();
	void killBackup();
	virtual int addLine(std::string const & line) // add a line to end of buffer
	  {
	    return vTextEditor::addLine ( line.c_str() );
	  }

	virtual void ChangeLoc(long line, int col);
	virtual void ChangeInsMode(int IsInsMode, char* = 0);
	virtual void StatusMessage(char *msg);
	virtual void ErrorMsg(char *str);
 	virtual void EnterFocus();
	virtual void adjustLines(long line_1, int by);
	virtual void setColorScheme();

      protected:	//--------------------------------------- protected
          void paintLine(char* linout, int lineStart,
              int hiStart, int hiLast, long lineNum);
          virtual void TextMouseDown(int row, int col, int button);
          virtual void TextMouseUp(int row, int col, int button);
#ifdef VIDE_WHEEL
	  void MouseWheelMove(int delta);
#endif

      private:		//--------------------------------------- private
          int parseC(char* linout, ChrAttr* attrs, 
		long lineNum, FileType ft);
          int parseFortran(char* linout, ChrAttr* attrs, long lineNum);
          int parseHTML(char* linout, ChrAttr* attrs, long lineNum);
          int parseTeX(char* linout, ChrAttr* attrs, long lineNum);
          int isCKeyWord(char* token);
          int isFortranKeyWord(char* token);
          int isPerlKeyWord(char* token);
          int isPerlOp(char* token);
          int isJavaKeyWord(char* token);
          int isHTMLKeyWord(char* token);
	  void formatLine(char* lin, char* lout);
	  int curColors;
	  string backupName;
	  vPopupMenu* _popMenu;
	  
      };
#endif
